"use strict";

var _excluded = ["renderValue"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormImperativeItem = void 0;

var react_1 = __importStar(require("react"));

var form_item_1 = require("./form-item");

var date_picker_1 = __importDefault(require("../date-picker"));

var Inner = react_1.forwardRef(function (props, ref) {
  react_1.useImperativeHandle(ref, function () {
    return {
      trigger: _async(function () {
        return _await(date_picker_1["default"].prompt({
          defaultValue: props.value
        }), function (v) {
          if (v !== null) {
            props.onChange == null ? void 0 : props.onChange(v);
          }
        });
      })
    };
  });
  return react_1["default"].createElement(react_1["default"].Fragment, null, props.renderValue(props.value));
});

exports.FormImperativeItem = function (props) {
  var renderValue = props.renderValue,
      formItemProps = _objectWithoutPropertiesLoose(props, _excluded);

  var ref = react_1.useRef(null);
  return react_1["default"].createElement(form_item_1.FormItem, Object.assign({}, formItemProps, {
    onClick: function onClick() {
      var _ref$current;

      (_ref$current = ref.current) == null ? void 0 : _ref$current.trigger();
    }
  }), react_1["default"].createElement(Inner, {
    ref: ref,
    renderValue: renderValue
  }));
};