"use strict";

var _excluded = ["className", "style", "hasFeedback", "children", "layout", "footer"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Form = void 0;

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var list_1 = __importDefault(require("../list"));

var rc_field_form_1 = __importDefault(require("rc-field-form"));

var context_1 = require("./context");

var with_default_props_1 = require("../../utils/with-default-props");

var defaultProps = {
  hasFeedback: true,
  layout: 'vertical'
};

exports.Form = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var className = props.className,
      style = props.style,
      hasFeedback = props.hasFeedback,
      children = props.children,
      layout = props.layout,
      footer = props.footer,
      formProps = _objectWithoutPropertiesLoose(props, _excluded);

  return react_1["default"].createElement(rc_field_form_1["default"], Object.assign({
    className: classnames_1["default"]('am-form', className),
    style: style
  }, formProps), react_1["default"].createElement(list_1["default"], {
    style: {
      '--prefix-width': '6em',
      '--align-items': 'stretch'
    }
  }, react_1["default"].createElement(context_1.FormContext.Provider, {
    value: {
      hasFeedback: hasFeedback,
      layout: layout
    }
  }, children)), footer && react_1["default"].createElement("div", {
    className: 'am-form-footer'
  }, footer));
};