"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-space";
var Space = with_default_props_1.withDefaultProps({
  direction: 'horizontal'
})(function (props) {
  var _classnames_1$default;

  var size = props.size,
      direction = props.direction,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style;
  var sizeStyle = {};

  if (size) {
    var _ref = Array.isArray(size) ? size : [size, size],
        horizontalSize = _ref[0],
        verticalSize = _ref[1];

    sizeStyle = {
      '--vertical-size': typeof verticalSize === 'number' ? verticalSize + "px" : verticalSize,
      '--horizontal-size': typeof horizontalSize === 'number' ? horizontalSize + "px" : horizontalSize
    };
  }

  return react_1["default"].createElement("div", {
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-wrap"] = props.wrap, _classnames_1$default[classPrefix + "-block"] = props.block, _classnames_1$default[classPrefix + "-" + direction] = true, _classnames_1$default[classPrefix + "-align-" + props.align] = !!props.align, _classnames_1$default), props.className),
    style: _extends({}, sizeStyle, style)
  }, react_1["default"].Children.map(props.children, function (child) {
    return react_1["default"].createElement("div", {
      className: classPrefix + "-item"
    }, child);
  }));
});
exports["default"] = Space;