function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _excluded = ["renderValue"];
import React, { forwardRef, useImperativeHandle, useRef } from 'react';
import { FormItem } from './form-item';
import DatePicker from '../date-picker';

function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }

  if (!value || !value.then) {
    value = Promise.resolve(value);
  }

  return then ? value.then(then) : value;
}

var Inner = /*#__PURE__*/forwardRef(function (props, ref) {
  useImperativeHandle(ref, function () {
    return {
      trigger: _async(function () {
        return _await(DatePicker.prompt({
          defaultValue: props.value
        }), function (v) {
          if (v !== null) {
            props.onChange == null ? void 0 : props.onChange(v);
          }
        });
      })
    };
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, props.renderValue(props.value));
});

function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }

    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}

export var FormImperativeItem = function FormImperativeItem(props) {
  var renderValue = props.renderValue,
      formItemProps = _objectWithoutPropertiesLoose(props, _excluded);

  var ref = useRef(null);
  return /*#__PURE__*/React.createElement(FormItem, Object.assign({}, formItemProps, {
    onClick: function onClick() {
      var _ref$current;

      (_ref$current = ref.current) == null ? void 0 : _ref$current.trigger();
    }
  }), /*#__PURE__*/React.createElement(Inner, {
    ref: ref,
    renderValue: renderValue
  }));
};