function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import classNames from 'classnames';
import { withDefaultProps } from '../../utils/with-default-props';
var classPrefix = "am-space";
var Space = withDefaultProps({
  direction: 'horizontal'
})(function (props) {
  var _classNames;

  var size = props.size,
      direction = props.direction,
      _props$style = props.style,
      style = _props$style === void 0 ? {} : _props$style;
  var sizeStyle = {};

  if (size) {
    var _ref = Array.isArray(size) ? size : [size, size],
        horizontalSize = _ref[0],
        verticalSize = _ref[1];

    sizeStyle = {
      '--vertical-size': typeof verticalSize === 'number' ? verticalSize + "px" : verticalSize,
      '--horizontal-size': typeof horizontalSize === 'number' ? horizontalSize + "px" : horizontalSize
    };
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, (_classNames = {}, _classNames[classPrefix + "-wrap"] = props.wrap, _classNames[classPrefix + "-block"] = props.block, _classNames[classPrefix + "-" + direction] = true, _classNames[classPrefix + "-align-" + props.align] = !!props.align, _classNames), props.className),
    style: _extends({}, sizeStyle, style)
  }, React.Children.map(props.children, function (child) {
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item"
    }, child);
  }));
});
export default Space;